//=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
//                    This source created by dlg2src
//                    Target: C++/TCLib
//=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
#include <windows.h>
#define   x64

#pragma warning(disable: 4312) // remove warning C4312: 'type cast': conversion from 'long' to 'HMENU' of greater size
#pragma warning(disable: 4267) // remove warning C4267: conversion from 'size_t' to 'int', possible loss of data
#pragma warning(disable: 4244) // remove warning C4244: conversion from 'ssize_t' to 'int', possible loss of data

#include "..\TCLib\stdio.h"
#include "..\TCLib\string.h"
#include "..\TCLib\stdlib.h"
#include "..\TCLib\memory.h"
#include "..\TCLib\malloc.h"
#include "..\TCLib\math.h"
#include "..\TCLib\tchar.h"
#include "..\TCLib\Strings.cpp"
#include <commctrl.h>

//#include <vector>
#include "Tools.h"

#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"gdi32.lib")
#pragma comment(lib,"advapi32.lib")

#pragma warning(disable: 4312) // remove warning C4312: 'type cast': conversion from 'long' to 'HMENU' of greater size

#define ID_INDEX       100
#define ID_COMPANY     101
#define ID_LASTNAME    102
#define ID_FIRSTNAME   103
#define ID_ADDRESS1    104
#define ID_ADDRESS2    105
#define ID_ADDRESS3    106
#define ID_CITYNAME    107
#define ID_STATENAME   108
#define ID_ZIPCODE     109
#define ID_COUNTRY     110
#define ID_PHONE       111
#define ID_FAX         112
#define ID_EMAIL       113
#define ID_URL         114
#define ID_COMMENTS    115

#define ID_PRIOR       121
#define ID_NEXT        122
#define ID_ADD         123
#define ID_UPDATE      124
#define ID_FIND        125
#define ID_DELETE      126
#define ID_PRINT       127

#define ID_MENU_CLOSE  IDCANCEL
#define ID_MENU_CUT    201
#define ID_MENU_COPY   202
#define ID_MENU_PASTE  203
#define ID_MENU_HELP   204
#define ID_MENU_ABOUT  205

#define WM_APPLYFOCUS  WM_USER + 999

struct AddressType {
    WCHAR Company[64];
    WCHAR LastName[32];
    WCHAR FirstName[32];
    WCHAR Address1[64];
    WCHAR Address2[64];
    WCHAR Address3[64];
    WCHAR CityName[24];
    WCHAR StateName[4];
    WCHAR ZipCode[12];
    long Country;
    WCHAR Phone[24];
    WCHAR Fax[24];
    WCHAR Email[64];
    WCHAR Url[64];
    WCHAR Comments[1024];
};

struct PROP {
    HFONT     usefont;
    HINSTANCE hinstance;
    long      isrecmodified;
    long      isfilemodified;
    long      currententry;
    long      maxentries;
    WCHAR     findtext[MAX_PATH];
};

//vector<AddressType> gAddressBook;
AddressType gAddressBook[100];
PROP gP;

HWND addLabel(IN HWND hParent, IN long nID, IN WCHAR* zCaption, IN long x, IN long y, IN long w, IN long h, IN DWORD dwStyle) {
    HWND hCtrl = 0;
    hCtrl = CreateWindowEx(0, L"Static", zCaption, dwStyle, dpi(x), dpi(y), dpi(w), dpi(h), hParent, (HMENU) nID, gP.hinstance, NULL);
    if (hCtrl) { SendMessage(hCtrl, WM_SETFONT, (WPARAM) gP.usefont, 0); }
    return hCtrl;
}

HWND addTextBox(IN HWND hParent, IN long nID, IN WCHAR* zCaption, IN long x, IN long y, IN long w, IN long h, IN DWORD dwStyle) {
    HWND hCtrl = 0;
    hCtrl = CreateWindowEx(WS_EX_CLIENTEDGE, L"Edit", zCaption, dwStyle, dpi(x), dpi(y), dpi(w), dpi(h), hParent, (HMENU) nID, gP.hinstance, NULL);
    if (hCtrl) { SendMessage(hCtrl, WM_SETFONT, (WPARAM) gP.usefont, 0); }
    return hCtrl;
}

HWND addComboBox(IN HWND hParent, IN long nID, IN WCHAR* zCaption, IN long x, IN long y, IN long w, IN long h, IN DWORD dwStyle) {
    HWND hCtrl = 0;
    hCtrl = CreateWindowEx(0, L"ComboBox", zCaption, dwStyle, dpi(x), dpi(y), dpi(w), dpi(h), hParent, (HMENU) nID, gP.hinstance, NULL);
    if (hCtrl) { SendMessage(hCtrl, WM_SETFONT, (WPARAM) gP.usefont, 0); }
    return hCtrl;
}

HWND addButton(IN HWND hParent, IN long nID, IN WCHAR* zCaption, IN long x, IN long y, IN long w, IN long h, IN DWORD dwStyle) {
    HWND hCtrl = 0;
    hCtrl = CreateWindowEx(0, L"Button", zCaption, dwStyle, dpi(x), dpi(y), dpi(w), dpi(h), hParent, (HMENU) nID, gP.hinstance, NULL);
    if (hCtrl) { SendMessage(hCtrl, WM_SETFONT, (WPARAM) gP.usefont, 0); }
    return hCtrl;
}

LRESULT Combo_Add(IN HWND hCtrl, IN WCHAR* zTmp) {
    LRESULT nIndex = 0;
    if (hCtrl) {
       if (wcslen(zTmp)) { nIndex = SendMessage(hCtrl, CB_ADDSTRING, 0, (LPARAM) zTmp); }
    }
    return nIndex;
}

void addCountries(IN HWND hCtrl) {
    Combo_Add(hCtrl, L"United States");
    Combo_Add(hCtrl, L"Afghanistan");
    Combo_Add(hCtrl, L"Albania");
    Combo_Add(hCtrl, L"Algeria");
    Combo_Add(hCtrl, L"Andorra");
    Combo_Add(hCtrl, L"Angola");
    Combo_Add(hCtrl, L"Anguilla");
    Combo_Add(hCtrl, L"Antarctica");
    Combo_Add(hCtrl, L"Argentina");
    Combo_Add(hCtrl, L"Armenia");
    Combo_Add(hCtrl, L"Aruba");
    Combo_Add(hCtrl, L"Australia");
    Combo_Add(hCtrl, L"Austria");
    Combo_Add(hCtrl, L"Azerbaijan");
    Combo_Add(hCtrl, L"Bahamas");
    Combo_Add(hCtrl, L"Bahrain");
    Combo_Add(hCtrl, L"Bangladesh");
    Combo_Add(hCtrl, L"Barbados");
    Combo_Add(hCtrl, L"Belarus");
    Combo_Add(hCtrl, L"Belgium");
    Combo_Add(hCtrl, L"Belize");
    Combo_Add(hCtrl, L"Benin");
    Combo_Add(hCtrl, L"Bermuda");
    Combo_Add(hCtrl, L"Bhutan");
    Combo_Add(hCtrl, L"Bolivia");
    Combo_Add(hCtrl, L"Botswana");
    Combo_Add(hCtrl, L"Bouvet Island");
    Combo_Add(hCtrl, L"BosniaHerzogovina");
    Combo_Add(hCtrl, L"Brazil");
    Combo_Add(hCtrl, L"Brunei");
    Combo_Add(hCtrl, L"Bulgaria");
    Combo_Add(hCtrl, L"Burkina Faso");
    Combo_Add(hCtrl, L"Cambodia");
    Combo_Add(hCtrl, L"Cameroon");
    Combo_Add(hCtrl, L"Canada");
    Combo_Add(hCtrl, L"Cape Verde");
    Combo_Add(hCtrl, L"Cayman Islands");
    Combo_Add(hCtrl, L"Central African Rep");
    Combo_Add(hCtrl, L"Chad");
    Combo_Add(hCtrl, L"Chile");
    Combo_Add(hCtrl, L"China");
    Combo_Add(hCtrl, L"Christmas Island");
    Combo_Add(hCtrl, L"Colombia");
    Combo_Add(hCtrl, L"Comoros");
    Combo_Add(hCtrl, L"Congo");
    Combo_Add(hCtrl, L"Cook Islands");
    Combo_Add(hCtrl, L"Costa Rica");
    Combo_Add(hCtrl, L"Croatia");
    Combo_Add(hCtrl, L"Cuba");
    Combo_Add(hCtrl, L"Cyprus");
    Combo_Add(hCtrl, L"Czech Republic");
    Combo_Add(hCtrl, L"Denmark");
    Combo_Add(hCtrl, L"Djibouti");
    Combo_Add(hCtrl, L"Dominica");
    Combo_Add(hCtrl, L"Dominican Republic");
    Combo_Add(hCtrl, L"East Timor");
    Combo_Add(hCtrl, L"Ecuador");
    Combo_Add(hCtrl, L"Egypt");
    Combo_Add(hCtrl, L"El Salvador");
    Combo_Add(hCtrl, L"Equatorial Guinea");
    Combo_Add(hCtrl, L"Eritrea");
    Combo_Add(hCtrl, L"Estonia");
    Combo_Add(hCtrl, L"Ethiopia");
    Combo_Add(hCtrl, L"Falkland Islands");
    Combo_Add(hCtrl, L"Faroe Islands");
    Combo_Add(hCtrl, L"Fiji");
    Combo_Add(hCtrl, L"Finland");
    Combo_Add(hCtrl, L"France");
    Combo_Add(hCtrl, L"France Metropolitan");
    Combo_Add(hCtrl, L"French Guiana");
    Combo_Add(hCtrl, L"French Polynesia");
    Combo_Add(hCtrl, L"French S. Territories");
    Combo_Add(hCtrl, L"Gabon");
    Combo_Add(hCtrl, L"Gambia");
    Combo_Add(hCtrl, L"Georgia");
    Combo_Add(hCtrl, L"Germany");
    Combo_Add(hCtrl, L"Ghana");
    Combo_Add(hCtrl, L"Gibraltar");
    Combo_Add(hCtrl, L"Greece");
    Combo_Add(hCtrl, L"Greenland");
    Combo_Add(hCtrl, L"Grenada");
    Combo_Add(hCtrl, L"Guadeloupe");
    Combo_Add(hCtrl, L"Guam");
    Combo_Add(hCtrl, L"Guatemala");
    Combo_Add(hCtrl, L"Guinea");
    Combo_Add(hCtrl, L"Guinea-Bissau");
    Combo_Add(hCtrl, L"Guyana");
    Combo_Add(hCtrl, L"Haiti");
    Combo_Add(hCtrl, L"Honduras");
    Combo_Add(hCtrl, L"Hong Kong");
    Combo_Add(hCtrl, L"Hungary");
    Combo_Add(hCtrl, L"Iceland");
    Combo_Add(hCtrl, L"IN India");
    Combo_Add(hCtrl, L"Indonesia");
    Combo_Add(hCtrl, L"Iran");
    Combo_Add(hCtrl, L"Iraq");
    Combo_Add(hCtrl, L"Ireland");
    Combo_Add(hCtrl, L"Israel");
    Combo_Add(hCtrl, L"Italy");
    Combo_Add(hCtrl, L"Ivory Coast");
    Combo_Add(hCtrl, L"Jamaica");
    Combo_Add(hCtrl, L"Japan");
    Combo_Add(hCtrl, L"Jordan");
    Combo_Add(hCtrl, L"Kazakhstan");
    Combo_Add(hCtrl, L"Kenya");
    Combo_Add(hCtrl, L"Kiribati");
    Combo_Add(hCtrl, L"Korea (North)");
    Combo_Add(hCtrl, L"Korea (South)");
    Combo_Add(hCtrl, L"Kuwait");
    Combo_Add(hCtrl, L"Kyrgyzstan");
    Combo_Add(hCtrl, L"Laos");
    Combo_Add(hCtrl, L"Latvia");
    Combo_Add(hCtrl, L"Lebanon");
    Combo_Add(hCtrl, L"Lesotho");
    Combo_Add(hCtrl, L"Liberia");
    Combo_Add(hCtrl, L"Libya");
    Combo_Add(hCtrl, L"Liechtenstein");
    Combo_Add(hCtrl, L"Lithuania");
    Combo_Add(hCtrl, L"Luxembourg");
    Combo_Add(hCtrl, L"Macau");
    Combo_Add(hCtrl, L"Macedonia");
    Combo_Add(hCtrl, L"Madagascar");
    Combo_Add(hCtrl, L"Malawi");
    Combo_Add(hCtrl, L"Malaysia");
    Combo_Add(hCtrl, L"Maldives");
    Combo_Add(hCtrl, L"Mali");
    Combo_Add(hCtrl, L"Malta");
    Combo_Add(hCtrl, L"Marshall Islands");
    Combo_Add(hCtrl, L"Martinique");
    Combo_Add(hCtrl, L"Mauritania");
    Combo_Add(hCtrl, L"Mauritius");
    Combo_Add(hCtrl, L"Mayotte");
    Combo_Add(hCtrl, L"Mexico");
    Combo_Add(hCtrl, L"Micronesia");
    Combo_Add(hCtrl, L"Miquelon");
    Combo_Add(hCtrl, L"Moldova");
    Combo_Add(hCtrl, L"Monaco");
    Combo_Add(hCtrl, L"Mongolia");
    Combo_Add(hCtrl, L"Montserrat");
    Combo_Add(hCtrl, L"Morocco");
    Combo_Add(hCtrl, L"Mozambique");
    Combo_Add(hCtrl, L"Myanmar");
    Combo_Add(hCtrl, L"Namibia");
    Combo_Add(hCtrl, L"Nauru");
    Combo_Add(hCtrl, L"Nepal");
    Combo_Add(hCtrl, L"Netherlands");
    Combo_Add(hCtrl, L"Nevis");
    Combo_Add(hCtrl, L"New Caledonia");
    Combo_Add(hCtrl, L"New Guinea");
    Combo_Add(hCtrl, L"New Zealand");
    Combo_Add(hCtrl, L"Nicaragua");
    Combo_Add(hCtrl, L"Niger");
    Combo_Add(hCtrl, L"Nigeria");
    Combo_Add(hCtrl, L"Niue");
    Combo_Add(hCtrl, L"Norfolk Island");
    Combo_Add(hCtrl, L"Norway");
    Combo_Add(hCtrl, L"Oman");
    Combo_Add(hCtrl, L"Pakistan");
    Combo_Add(hCtrl, L"Palau");
    Combo_Add(hCtrl, L"Panama");
    Combo_Add(hCtrl, L"Paraguay");
    Combo_Add(hCtrl, L"Peru");
    Combo_Add(hCtrl, L"Philippines");
    Combo_Add(hCtrl, L"Pitcairn");
    Combo_Add(hCtrl, L"Poland");
    Combo_Add(hCtrl, L"Portugal");
    Combo_Add(hCtrl, L"Principe");
    Combo_Add(hCtrl, L"Puerto Rico");
    Combo_Add(hCtrl, L"Qatar");
    Combo_Add(hCtrl, L"Reunion");
    Combo_Add(hCtrl, L"Romania");
    Combo_Add(hCtrl, L"Russian Federation");
    Combo_Add(hCtrl, L"Rwanda");
    Combo_Add(hCtrl, L"Saint Kitts");
    Combo_Add(hCtrl, L"Saint Lucia");
    Combo_Add(hCtrl, L"Samoa");
    Combo_Add(hCtrl, L"San Marino");
    Combo_Add(hCtrl, L"Sao Tome");
    Combo_Add(hCtrl, L"Saudi Arabia");
    Combo_Add(hCtrl, L"Senegal");
    Combo_Add(hCtrl, L"Seychelles");
    Combo_Add(hCtrl, L"Sierra Leone");
    Combo_Add(hCtrl, L"Singapore");
    Combo_Add(hCtrl, L"Slovak Republic");
    Combo_Add(hCtrl, L"Slovenia");
    Combo_Add(hCtrl, L"Solomon Islands");
    Combo_Add(hCtrl, L"Somalia");
    Combo_Add(hCtrl, L"South Africa");
    Combo_Add(hCtrl, L"Spain");
    Combo_Add(hCtrl, L"Sri Lanka");
    Combo_Add(hCtrl, L"St. Helena");
    Combo_Add(hCtrl, L"St. Pierre");
    Combo_Add(hCtrl, L"Sudan");
    Combo_Add(hCtrl, L"Suriname");
    Combo_Add(hCtrl, L"Swaziland");
    Combo_Add(hCtrl, L"Sweden");
    Combo_Add(hCtrl, L"Switzerland");
    Combo_Add(hCtrl, L"Syria");
    Combo_Add(hCtrl, L"Taiwan");
    Combo_Add(hCtrl, L"Tajikistan");
    Combo_Add(hCtrl, L"Tanzania");
    Combo_Add(hCtrl, L"Thailand");
    Combo_Add(hCtrl, L"Tobago");
    Combo_Add(hCtrl, L"Togo");
    Combo_Add(hCtrl, L"Tokelau");
    Combo_Add(hCtrl, L"Tonga");
    Combo_Add(hCtrl, L"Trinidad");
    Combo_Add(hCtrl, L"Tunisia");
    Combo_Add(hCtrl, L"Turkey");
    Combo_Add(hCtrl, L"Turkmenistan");
    Combo_Add(hCtrl, L"Tuvalu");
    Combo_Add(hCtrl, L"Uganda");
    Combo_Add(hCtrl, L"Ukraine");
    Combo_Add(hCtrl, L"United Arab Emirates");
    Combo_Add(hCtrl, L"United Kingdom");
    Combo_Add(hCtrl, L"United States");
    Combo_Add(hCtrl, L"Uruguay");
    Combo_Add(hCtrl, L"Uzbekistan");
    Combo_Add(hCtrl, L"Vanuatu ");
    Combo_Add(hCtrl, L"Vatican City State");
    Combo_Add(hCtrl, L"Venezuela");
    Combo_Add(hCtrl, L"Viet Nam");
    Combo_Add(hCtrl, L"Virgin Islands (BR)");
    Combo_Add(hCtrl, L"Virgin Islands (US)");
    Combo_Add(hCtrl, L"Western Sahara");
    Combo_Add(hCtrl, L"Yemen");
    Combo_Add(hCtrl, L"Yugoslavia");
    Combo_Add(hCtrl, L"Zaire");
    Combo_Add(hCtrl, L"Zambia");
    Combo_Add(hCtrl, L"Zimbabwe");
    Combo_Add(hCtrl, L"Other");
}

DWORD FileSize(IN WCHAR* szFileSpec) {
    WIN32_FIND_DATA fd = {0};
    DWORD nRet = 0;
    if (wcslen(szFileSpec)) {
        HANDLE hFind;
        hFind = FindFirstFile(szFileSpec, &fd);
        if (hFind != INVALID_HANDLE_VALUE) {
            FindClose(hFind);
            nRet = fd.nFileSizeLow;
        }
    }
    return nRet;
}

void SetButtonStatus(IN HWND hWnd) {
    WCHAR wTxt[MAX_PATH];

    // If any current text is modified, make the ADD & Update buttons active
    if (gP.isrecmodified) {
        EnableWindow(GetDlgItem(hWnd, ID_ADD), TRUE);
        EnableWindow(GetDlgItem(hWnd, ID_UPDATE), TRUE);
    } else {
        EnableWindow(GetDlgItem(hWnd, ID_ADD), FALSE);
        EnableWindow(GetDlgItem(hWnd, ID_UPDATE), FALSE);
    }

    // Update the Index control text
    wcscpy(wTxt, STRL(gP.currententry));
    wcscat(wTxt, L" / "); wcscat(wTxt, STRL(gP.maxentries));
    SetWindowText(GetDlgItem(hWnd, ID_INDEX), wTxt);

    // Do we have any records? is not, disable the Prior/Next buttons, etc
    if (gP.maxentries) {
        // If there are records, allow the Find/Delete buttons
        EnableWindow(GetDlgItem(hWnd, ID_FIND), TRUE);
        EnableWindow(GetDlgItem(hWnd, ID_DELETE), TRUE);

        // We have records, so set the Prior button status according to the current index position
        if (gP.currententry < 2) {
            EnableWindow(GetDlgItem(hWnd, ID_PRIOR), FALSE);
        } else {
            EnableWindow(GetDlgItem(hWnd, ID_PRIOR), TRUE);
        }
        // Update the } control button
        if (gP.currententry >= gP.maxentries) {
            EnableWindow(GetDlgItem(hWnd, ID_NEXT), FALSE);
        } else {
            EnableWindow(GetDlgItem(hWnd, ID_NEXT), TRUE);
        }
    } else {
        EnableWindow(GetDlgItem(hWnd, ID_PRIOR), FALSE);
        EnableWindow(GetDlgItem(hWnd, ID_NEXT), FALSE);
        EnableWindow(GetDlgItem(hWnd, ID_FIND), FALSE);
        EnableWindow(GetDlgItem(hWnd, ID_DELETE), FALSE);
    }
}

void UdtToDialog(IN HWND hWnd, IN long Index) {
    Index--; // C++ array is 0 based
    AddressType Temp = { 0 };
    long SaveState = 0;

    if ((Index > -1) && (Index < UBOUND(gAddressBook))) {
        wmemcpy((WCHAR*) &Temp, (WCHAR*) &gAddressBook[Index], sizeof(AddressType));
    }

    // When we change the edit control data, we generate EN_UPDATE messages...
    // Due to the design of our GUI interface, we would end up with the ADD and UPDATE
    // buttons becoming enabled just because we loaded a new UDT record into the dialog.
    // to overcome this, we set the "modified" flag to TRUE, so the main callback
    // function ingores the "update" notication messages.

    SaveState = gP.isrecmodified;
    gP.isrecmodified = TRUE;

    SetWindowText(GetDlgItem(hWnd, ID_COMPANY),   RTRIM$(Temp.Company, $SPACE));
    SetWindowText(GetDlgItem(hWnd, ID_LASTNAME),  RTRIM$(Temp.LastName, $SPACE));
    SetWindowText(GetDlgItem(hWnd, ID_FIRSTNAME), RTRIM$(Temp.FirstName, $SPACE));
    SetWindowText(GetDlgItem(hWnd, ID_ADDRESS1),  RTRIM$(Temp.Address1, $SPACE));
    SetWindowText(GetDlgItem(hWnd, ID_ADDRESS2),  RTRIM$(Temp.Address2, $SPACE));
    SetWindowText(GetDlgItem(hWnd, ID_ADDRESS3),  RTRIM$(Temp.Address3, $SPACE));
    SetWindowText(GetDlgItem(hWnd, ID_CITYNAME),  RTRIM$(Temp.CityName, $SPACE));
    SetWindowText(GetDlgItem(hWnd, ID_STATENAME), RTRIM$(Temp.StateName, $SPACE));
    SetWindowText(GetDlgItem(hWnd, ID_ZIPCODE),   RTRIM$(Temp.ZipCode, $SPACE));
    SendMessage  (GetDlgItem(hWnd, ID_COUNTRY),   CB_SETCURSEL, Temp.Country - 1, 0);
    SetWindowText(GetDlgItem(hWnd, ID_PHONE),     RTRIM$(Temp.Phone, $SPACE));
    SetWindowText(GetDlgItem(hWnd, ID_FAX),       RTRIM$(Temp.Fax, $SPACE));
    SetWindowText(GetDlgItem(hWnd, ID_EMAIL),     RTRIM$(Temp.Email, $SPACE));
    SetWindowText(GetDlgItem(hWnd, ID_URL),       RTRIM$(Temp.Url, $SPACE));
    SetWindowText(GetDlgItem(hWnd, ID_COMMENTS),  RTRIM$(Temp.Comments, $SPACE));

    // Restore the previous state
    gP.isrecmodified = SaveState;
}

void DialogToUdt (IN HWND hWnd, IN long Index) {
    Index--; // C++ array is 0 based
    AddressType Temp = { 0 };

    if ((Index > -1) && (Index < UBOUND(gAddressBook))) {
        wmemcpy((WCHAR*) &Temp, (WCHAR*) &gAddressBook[Index], sizeof(AddressType));
        GetWindowText(GetDlgItem(hWnd, ID_COMPANY), Temp.Company, sizeof(Temp.Company));
        GetWindowText(GetDlgItem(hWnd, ID_LASTNAME), Temp.LastName, sizeof(Temp.LastName));
        GetWindowText(GetDlgItem(hWnd, ID_FIRSTNAME), Temp.FirstName, sizeof(Temp.FirstName));
        GetWindowText(GetDlgItem(hWnd, ID_ADDRESS1),Temp.Address1, sizeof(Temp.Address1));
        GetWindowText(GetDlgItem(hWnd, ID_ADDRESS2), Temp.Address2, sizeof(Temp.Address2));
        GetWindowText(GetDlgItem(hWnd, ID_ADDRESS3), Temp.Address3, sizeof(Temp.Address3));
        GetWindowText(GetDlgItem(hWnd, ID_CITYNAME), Temp.CityName, sizeof(Temp.CityName));
        GetWindowText(GetDlgItem(hWnd, ID_STATENAME), Temp.StateName, sizeof(Temp.StateName));
        GetWindowText(GetDlgItem(hWnd, ID_ZIPCODE), Temp.ZipCode, sizeof(Temp.ZipCode));
        Temp.Country = (long) SendMessage(GetDlgItem(hWnd, ID_COUNTRY), CB_GETCURSEL, 0, 0) + 1;
        GetWindowText(GetDlgItem(hWnd, ID_PHONE), Temp.Phone, sizeof(Temp.Phone));
        GetWindowText(GetDlgItem(hWnd, ID_FAX), Temp.Fax, sizeof(Temp.Fax));
        GetWindowText(GetDlgItem(hWnd, ID_EMAIL), Temp.Email, sizeof(Temp.Email));
        GetWindowText(GetDlgItem(hWnd, ID_URL), Temp.Url, sizeof(Temp.Url));
        GetWindowText(GetDlgItem(hWnd, ID_COMMENTS), Temp.Comments, sizeof(Temp.Comments));

        wmemcpy((WCHAR*) &gAddressBook[Index], (WCHAR*) &Temp, sizeof(AddressType));
    }
}

void Array_Resize(IN long maxenties) {
//zizi        gAddressBook.resize(gP.maxentries);
}

void Array_Erase(IN long entry) {
//zizi        gAddressBook.erase(gAddressBook.begin() + gP.currententry -1);
}

void AddUpdateRecord (IN HWND hWnd, IN WPARAM wParam) {
    // This function is only called if gP.isrecmodified is TRUE
    WCHAR LastName[32] = { 0 };
    AddressType Temp = { 0 };

    // Get the Last Name field
    GetWindowText(GetDlgItem(hWnd, ID_LASTNAME), LastName, sizeof(LastName));

    // Check if Last Name entered; at this stage will not check for duplicate entries
    if (wcslen(LastName) == 0) {
        // Display error message dialog
        MessageBox(hWnd, L"You must specify a Last Name!", $NULL, MB_ICONEXCLAMATION);
        // Move focus to the offending control
        SetFocus(GetDlgItem(hWnd, ID_LASTNAME));
        return;
    }

    // Now determine if ADD or UPDATE buttons clicked
    if ((LOINT(wParam) == ID_ADD) || (gP.maxentries < 1)) { // It's the Add button, or we have no existing entries
        // Extend the UDT array and insert the new address data
        gP.maxentries++;
        gP.currententry = gP.maxentries;
        Array_Resize(gP.maxentries);
    }

    // Get the data from the dialog
    DialogToUdt(hWnd, gP.currententry);

    // Reset the modified flag
    gP.isrecmodified = FALSE;

    // Flag data as modified
    gP.isfilemodified = TRUE;

    // Update the dialog controls
    SetButtonStatus(hWnd);

}

void DeleteRecord (IN HWND hWnd) {

    // Only permit a deletion if the index is valid
    if ((gP.currententry < 1) || (gP.currententry > gP.maxentries)) { return; }

    // Confirm deletion
    if (MessageBox(hWnd, L"Are you sure you want to delete this record?",
                   L"Delete Record", MB_ICONQUESTION | MB_OKCANCEL) == IDCANCEL) { return; }

    // Now perform the removal of the record and update our index variables
    //array delete gAddressBook[gP.currententry];
    Array_Erase(gP.currententry -1);
    gP.maxentries--;
    gP.currententry = min(gP.currententry, gP.maxentries);
    Array_Resize(max(1, gP.maxentries));

    // Update our status flags & refresh the window
    gP.isrecmodified = FALSE;
    gP.isfilemodified = TRUE;
    SetButtonStatus(hWnd);
    UdtToDialog(hWnd, gP.currententry);

}

LRESULT CALLBACK FindDialogProc (IN HWND hWnd, IN UINT uMsg, IN WPARAM wParam, IN LPARAM lParam) {
    long K = 0, wID = 0;
    HWND hParent = 0;
    WCHAR wFindText[MAX_PATH] = { 0 };
    WCHAR szRecord[sizeof(AddressType)] = { 0 };

    switch (uMsg) {
    case WM_COMMAND:
         wID = LOINT(wParam);
         switch (wID) {
         case IDCANCEL:
              if (HIINT(wParam) == BN_CLICKED) {
                  SendMessage(hWnd, WM_CLOSE, 0, 0);
                  return 0;
              }
              break;

         case ID_FIND:
              // Retrieve the search text if the edit control contents change.
              // We save it in a global string variable so we can recreate the
              // Find dialog with the same search text if it is relaunched again.
              if (HIINT(wParam) == EN_UPDATE) {  // The text was changed
                  // Get the text and trim away eventual leading/trailing spaces
                  GetWindowText(GetDlgItem(hWnd, ID_FIND), gP.findtext, sizeof(gP.findtext));
                  wcscpy(gP.findtext, TRIM$(gP.findtext, $SPACE));
              }
              return 0;

         case IDOK:  // Ok button
              // Now initiate a search as long as the search text is available
              if ((HIINT(wParam) == BN_CLICKED) && (wcslen(gP.findtext))) {
                  // Get main dialog handle
                  hParent = GetParent(hWnd);
                  // Start search from end record and loop from end to start
                  wcscpy(wFindText, CharUpper(gP.findtext));
                  for (K = gP.currententry; K < gP.maxentries; K++) {
                      wmemcpy((WCHAR*) &szRecord, (WCHAR*) &gAddressBook[K], sizeof(AddressType));
                      CharUpper(szRecord);
                      if (INSTRPOS(szRecord, wFindText)) {
                          gP.isrecmodified = FALSE;
                          gP.currententry = K + 1;
                          UdtToDialog(hParent, gP.currententry);
                          SetButtonStatus(hParent);
                          return 0;
                      }
                  }

                  // No match between index and end, so restart from beginning of file
                  for (K = 0; K < gP.currententry; K++) {
                      wmemcpy((WCHAR*) &szRecord, (WCHAR*) &gAddressBook[K], sizeof(AddressType));
                      CharUpper(szRecord);
                      if (INSTRPOS(szRecord, wFindText)) {
                          gP.isrecmodified = FALSE;
                          gP.currententry = K + 1;
                          UdtToDialog(hParent, gP.currententry);
                          SetButtonStatus(hParent);
                          return 0;
                      }
                  }
                  // Hmmm... no matches at all!
                  // By disabling the Modeless Find dialog while the MSGBOX is shown,
                  // we ensure the parent dialog keeps its zOrder and regains focus
                  // when the Find dialog is closed, else Windows may lose track of
                  // it and send it to the back..
                  EnableWindow(hWnd, FALSE);
                  MessageBox(hParent, L"Find record", L"No occurrences found.", MB_ICONERROR | MB_TASKMODAL);
                  EnableWindow(hWnd, TRUE);
              }
              return 0;
         }
         break;

    case WM_DESTROY:
         EnableWindow(GetParent(hWnd), 1);
         // Close the main window
         PostQuitMessage(0);
         return 0;
    }

    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

long FindDialog (IN HWND hParent) {
    long nRet = 0;
    long x = 0, y = 0, w = 0, h = 0, K = 0, nWidth = 0, nHeight = 0, IsInitialized = 0;
    HWND hWnd = 0, hCtrl = 0;
    WNDCLASSEX wcx = { 0 };
    MSG msg = { 0 } ;
    RECT rc = { 0 }, rw = { 0 };
    DWORD dwStyle = 0, dwExStyle = 0;

    WCHAR zClass[] = L"TOOLFIND";
    wcx.cbSize = sizeof(wcx);
    IsInitialized = GetClassInfoEx(gP.hinstance, zClass, &wcx);
    if (!IsInitialized) {
        wcx.style         = CS_HREDRAW | CS_VREDRAW;
        wcx.lpfnWndProc   = FindDialogProc;
        wcx.cbClsExtra    = 0;
        wcx.cbWndExtra    = 0;
        wcx.hInstance     = gP.hinstance;
        wcx.hIcon         = NULL;
        wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
        wcx.hbrBackground = (HBRUSH) COLOR_BTNSHADOW;
        wcx.lpszMenuName  = NULL;
        wcx.lpszClassName = zClass;
        wcx.hIconSm       = wcx.hIcon;
        if (RegisterClassEx(&wcx)) { IsInitialized = TRUE; }
    }

    if (IsInitialized) {

        SetRect(&rc, 0, 0, dpi(231), dpi(112));
        // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
        // but it won't hurt anything to keep it, in case we change our mind ;)
        dwStyle = WS_POPUP | WS_CAPTION | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_SYSMENU;
        dwExStyle = WS_EX_TOOLWINDOW;
        AdjustWindowRectEx(&rc, dwStyle, FALSE, dwExStyle);
        w = rc.right - rc.left; h = rc.bottom - rc.top;
        hWnd = CreateWindowEx(dwExStyle, zClass, L"Find Record", dwStyle, 0, 0, w, h, hParent, 0, gP.hinstance, NULL);
        if (hWnd) {
            // Add the controls
            hCtrl = addLabel(hWnd, -1, L"Find &Text:", dpi(3), dpi(30), dpi(55), dpi(16), WS_CHILD | WS_VISIBLE | SS_RIGHT);
            hCtrl = addTextBox(hWnd, ID_FIND, gP.findtext, dpi(61), dpi(26), dpi(154), dpi(22), WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_AUTOHSCROLL);
            SetFocus(hCtrl);
            dwStyle = WS_CHILD | WS_VISIBLE | WS_TABSTOP;
            hCtrl = addButton(hWnd, IDOK, L"&Find Next", dpi(86), dpi(76), dpi(60), dpi(23), dwStyle);
            hCtrl = addButton(hWnd, IDCANCEL, L"&Cancel", dpi(155), dpi(76), dpi(60), dpi(23), dwStyle);

            // Center the child popup in the parent window.
            GetWindowRect(hParent, &rw); nWidth = rw.right - rw.left; nHeight = rw.bottom - rw.top;
            GetWindowRect(hWnd, &rc); w = rc.right - rc.left; h = rc.bottom - rc.top;
            x = rw.left + ((nWidth - w) / 2);
            y = rw.top + ((nHeight - h) / 2);
            MoveWindow(hWnd, x, y, w, h, 0);

            EnableWindow(hParent, 0); // Disable the parent to make it a modal tool window, see also WM_DESTROY
            ShowWindow(hWnd, SW_SHOW);

            while (GetMessage(&msg, NULL, 0, 0)) {
                if (IsDialogMessage(hWnd, &msg) == 0) {
                    TranslateMessage(&msg);
                    DispatchMessage(&msg);
                }
            }

            BringWindowToTop(hParent);
            nRet = (long) msg.wParam;
        }
    }
    return nRet;
}

void ShowButtons(IN HWND hWnd, IN long Visibility) {
    for (long  K = ID_PRIOR; K <= ID_PRINT; K++) {
        ShowWindow(GetDlgItem(hWnd, K), Visibility);
    }
    ShowWindow(GetDlgItem(hWnd, IDCANCEL), Visibility);
}

long PrintThisWindow(IN HWND hWnd) {
    WCHAR szBuffer[MAX_PATH] = { 0 };
    HDC hDCprint = 0;
    DWORD nBufferSize = MAX_PATH;
    long nRet = 0;
    if (GetDefaultPrinter(szBuffer, &nBufferSize)) {
        hDCprint = CreateDC(NULL, szBuffer, NULL, NULL);
        if (hDCprint) {
            RECT rc = { 0 };
            DOCINFO dinfo = { 0 };
            long hRes  = GetDeviceCaps(hDCprint, HORZRES);
            long vRes  = GetDeviceCaps(hDCprint, VERTRES);

            long offsetX = 15; 
            long offsetY = 60;
            GetClientRect(hWnd, &rc);

            HDC hScreenDC = GetDC(0);
            HDC hDC = CreateCompatibleDC(hScreenDC);
            HBITMAP hBmp = CreateCompatibleBitmap(hScreenDC, rc.right, rc.bottom);
            SelectObject(hDC, hBmp);

            // Hide the buttons
            ShowButtons(hWnd, SW_HIDE);
            // Windows do the WM_PRINTCLIENT for us
            PrintWindow(hWnd, hDC, PW_CLIENTONLY);
            // Show the buttons
            ShowButtons(hWnd, SW_SHOW);

            float rCoef = min((hRes - (offsetX * 2)) / (float) rc.right, (vRes - (offsetY * 2)) / (float) rc.bottom);
            long fxSize = (long) (rc.right * rCoef);
            long fySize = (long) (rc.bottom * rCoef);
            long xtop = (hRes - fxSize) / 2 + offsetX;
            long ytop = (vRes - fySize) / 2 + offsetY;

            dinfo.cbSize = sizeof(dinfo);
            dinfo.lpszDocName = NULL;
            dinfo.lpszOutput = NULL;
            if (StartDoc(hDCprint, &dinfo) > 0) {
                if (StartPage(hDCprint) > 0) {
                    // Paint the bitmap
                    if (hBmp) {

                        BITMAP bm = { 0 };
                        HDC dcBitmap = CreateCompatibleDC(0);

                        GetObject(hBmp, sizeof(bm), &bm);
                        BITMAPINFO bi = { 0 };
                        bi.bmiHeader.biSize = sizeof(bi.bmiHeader);
                        bi.bmiHeader.biWidth = bm.bmWidth;
                        bi.bmiHeader.biHeight = bm.bmHeight;
                        bi.bmiHeader.biPlanes = 1;
                        bi.bmiHeader.biBitCount = bm.bmBitsPixel;
                        bi.bmiHeader.biCompression = BI_RGB;

                        // Calculate space needed for the dib bits
                        DWORD nBufSize = (bm.bmWidth + 1) * (bm.bmBitsPixel / 8);
                        nBufSize = ((nBufSize + 3) / 4) * 4;
                        nBufSize = nBufSize * bm.bmHeight;

                        HGLOBAL ghnd = GlobalAlloc(GMEM_MOVEABLE, nBufSize);
                        LPVOID gptr = GlobalLock(ghnd);

                        if (GetDIBits(dcBitmap, hBmp, 0, bm.bmHeight, gptr, &bi, 0)) {
                            nRet = StretchDIBits(hDCprint, xtop, ytop, fxSize, fySize, 0, 0,
                                                 bm.bmWidth, bm.bmHeight, gptr, &bi, 0, SRCCOPY);
                        }

                        GlobalUnlock(ghnd);
                        GlobalFree(ghnd);
                        DeleteDC(dcBitmap);

                    }

                    if (EndPage(hDCprint) > 0) {
                        EndDoc(hDCprint);
                    }
                }
            }

            // Release
            DeleteDC(hDC);
            DeleteObject(hBmp);
            ReleaseDC(0, hScreenDC);

            DeleteDC(hDCprint);
        }

    }
    return nRet;
}

LRESULT CALLBACK WndProc(IN HWND hWnd, IN UINT uMsg, IN WPARAM wParam, IN LPARAM lParam) {

    static HWND hFocus;

    switch (uMsg) {

    case WM_NCACTIVATE:
         // Save the handle of the control that has the focus
         if (wParam == 0) { hFocus = GetFocus(); }
         break;

    case WM_SETFOCUS:
         // Post a message to set the focus later, since some
         // Windows actions can steal it if we set it here
         if (hFocus) {
             PostMessage(hWnd, WM_APPLYFOCUS, (WPARAM) hFocus, 0);
             hFocus = 0;
         }
         break;

    case WM_APPLYFOCUS:
         // Set the focus
         if (wParam) { SetFocus((HWND) wParam); }
         return 0;

    case WM_COMMAND:
         if ((HIINT(wParam) == EN_UPDATE) // Any edit control was changed
             || ((LOINT(wParam) == ID_COUNTRY) && (HIINT(wParam) == CBN_SELCHANGE))) {   // The country combobox was changed
             // if this is the first "change" message, we need to update the controls in the dialog box.
             if (gP.isrecmodified == 0) {
                 gP.isrecmodified = TRUE;
                 SetButtonStatus(hWnd);
             }
         }

         // Messages from controls and menu items are handled here.
         switch (LOINT(wParam)) {
         case IDCANCEL:
              // if the Escape key has been pressed...
              if (HIINT(wParam) == BN_CLICKED) {
                  // Shut down the application by sending a WM_CLOSE message
                  SendMessage(hWnd, WM_CLOSE, 0, 0);
                  return 0;
              }

         case ID_PRIOR:
              gP.currententry = max(gP.currententry - 1, 1);
              // Disregard any existing editing if one of these button clicked
              gP.isrecmodified = FALSE;
              // Update the dialog
              UdtToDialog(hWnd, gP.currententry);
              // Update the Prior/} control button status
              SetButtonStatus(hWnd);
              return 0;

         case ID_NEXT:
              gP.currententry = min(gP.currententry + 1, gP.maxentries);
              // Disregard any existing editing if one of these button clicked
              gP.isrecmodified = FALSE;
              // Update the dialog
              UdtToDialog(hWnd, gP.currententry);
              // Update the Prior/} control button status
              SetButtonStatus(hWnd);
              return 0;

         case ID_FIND:
              FindDialog(hWnd);
              return 0;

         case ID_ADD:
         case ID_UPDATE:
              AddUpdateRecord(hWnd, wParam);
              return 0;

         case ID_DELETE:
              DeleteRecord(hWnd);
              return 0;

         case ID_PRINT:
              if (PrintThisWindow(hWnd)) {
                  MessageBox(hWnd, L"\nAddress printed successfully.", L"Info", MB_ICONINFORMATION);
              } else {
                  MessageBox(hWnd, L"\nUnable to print this address.", L"Printer error", MB_ICONEXCLAMATION);
              }
              return 0;

         case ID_MENU_HELP:
              MessageBox(hWnd, L"Help not implemented", L"Info", MB_ICONINFORMATION);
              return 0;

         case ID_MENU_ABOUT:
              MessageBox(hWnd, L"\nAddress Book by PowerBASIC, Inc.\n\nSDK translation by Patrice Terrier.", L"Address Book", MB_ICONINFORMATION);
              return 0;
         }
         break;

    case WM_DESTROY:
         PostQuitMessage(0);
         return 0;

    }

    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

int WINAPI wWinMain(IN HINSTANCE hInstance, IN HINSTANCE hPrevInstance, IN LPTSTR lpCmdLine, IN int nCmdShow) {
    long nRet = 0;
    HWND hWnd = 0, hCtrl = 0;
    WNDCLASSEX wcx = { 0 };
    HANDLE hFile = 0;
    DWORD ByttesReaded = 0, BytesWritten = 0;
    MSG msg = { 0 };

    gP.usefont = (HFONT) GetStockObject(DEFAULT_GUI_FONT); // Tahoma
    gP.hinstance = hInstance;

    WCHAR szFilename[] = L"UADDRESS.DAT";
    DWORD BufferSize = FileSize(szFilename);
    if (BufferSize) {
        gP.currententry = 1;
        gP.maxentries = BufferSize / sizeof(AddressType);
        Array_Resize(gP.maxentries);
        hFile = CreateFile(szFilename, GENERIC_READ, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
        if (hFile != INVALID_HANDLE_VALUE) {
            ReadFile(hFile, &gAddressBook[0], BufferSize, &ByttesReaded, NULL);
            CloseHandle(hFile);
        }
    }

    WCHAR szClassName[] = L"SDKADDRESS64";
    wcx.cbSize = sizeof(wcx);
    long IsInitialized = GetClassInfoEx(hInstance, szClassName, &wcx);
    if (!IsInitialized) {
        wcx.style         = CS_HREDRAW | CS_VREDRAW;
        wcx.lpfnWndProc   = WndProc;
        wcx.cbClsExtra    = 0;
        wcx.cbWndExtra    = 0;
        wcx.hInstance     = hInstance;
        wcx.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
        wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
        wcx.hbrBackground = (HBRUSH) COLOR_BTNSHADOW;
        wcx.lpszMenuName  = NULL;
        wcx.lpszClassName = szClassName;
        wcx.hIconSm       = wcx.hIcon;
        if (RegisterClassEx(&wcx)) { IsInitialized = TRUE; }
    }
    if (IsInitialized) {
        RECT lpr = { 0 };
        DWORD dwStyleEx = WS_EX_CONTROLPARENT | WS_EX_WINDOWEDGE;
        DWORD dwStyle = WS_CLIPSIBLINGS | WS_CAPTION | WS_SYSMENU | DS_3DLOOK | DS_NOFAILCREATE | DS_SETFONT | DS_CENTER;
        SetRect(&lpr, 0, 0, dpi(606), dpi(462));
        AdjustWindowRectEx(&lpr, dwStyle, FALSE, dwStyleEx);
        long w = lpr.right - lpr.left; long x = (GetSystemMetrics(SM_CXSCREEN) - w) / 2;
        long h =  lpr.bottom - lpr.top; long y = (GetSystemMetrics(SM_CYSCREEN) - h) / 2;
        hWnd = CreateWindowEx(dwStyleEx, szClassName, L"Address Book - flat API SDK version", dwStyle, x, y, w, h, 0, 0, hInstance, NULL);
        if (hWnd) {
            DWORD dwLabelStyle = WS_CHILD | WS_VISIBLE | SS_RIGHT;
            DWORD dwEditStyle = WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_AUTOHSCROLL;

            hCtrl = addLabel(hWnd, - ID_INDEX, L"Record N", 455, 8, 90, 13, dwLabelStyle);
            hCtrl = addLabel(hWnd, ID_INDEX, L"0 / 0", 549, 7, 38, 16, WS_CHILD | WS_VISIBLE | SS_SUNKEN | SS_CENTER);

            hCtrl = addLabel(hWnd, - ID_COMPANY, L"Company", 8, 31, 90, 13, dwLabelStyle);
            hCtrl = addTextBox(hWnd, ID_COMPANY, $NULL, 102, 28, 485, 19, dwEditStyle);

            hCtrl = addLabel(hWnd, - ID_LASTNAME, L"Last Name", 8, 54, 90, 13, dwLabelStyle);
            hCtrl = addTextBox(hWnd, ID_LASTNAME, $NULL, 102, 51, 225, 19, dwEditStyle);

            hCtrl = addLabel(hWnd, - ID_FIRSTNAME, L"First", 329, 54, 27, 13, dwLabelStyle);
            hCtrl = addTextBox(hWnd, ID_FIRSTNAME, $NULL, 362, 51, 225, 19, dwEditStyle);

            hCtrl = addLabel(hWnd, - ID_ADDRESS1, L"Address", 8, 78, 90, 13, dwLabelStyle);
            hCtrl = addTextBox(hWnd, ID_ADDRESS1, $NULL, 102, 75, 485, 19, dwEditStyle);

            hCtrl = addTextBox(hWnd, ID_ADDRESS2, $NULL, 102, 99, 485, 19, dwEditStyle);
            hCtrl = addTextBox(hWnd, ID_ADDRESS3, $NULL, 102, 124, 485, 19, dwEditStyle);

            hCtrl = addLabel(hWnd, - ID_CITYNAME, L"City", 8, 151, 90, 13, dwLabelStyle);
            hCtrl = addTextBox(hWnd, ID_CITYNAME, $NULL, 102, 148, 174, 19, dwEditStyle);

            hCtrl = addLabel(hWnd, - ID_STATENAME, L"State/Province", 282, 151, 75, 13, dwLabelStyle);
            hCtrl = addTextBox(hWnd, ID_STATENAME, $NULL, 362, 148, 67, 19, dwEditStyle);

            hCtrl = addLabel(hWnd, - ID_ZIPCODE, L"Zip or Postal Code", 8, 177, 90, 13, dwLabelStyle);
            hCtrl = addTextBox(hWnd, ID_ZIPCODE, $NULL, 102, 174, 60, 19, dwEditStyle);

            hCtrl = addLabel(hWnd, - ID_COUNTRY, L"Country", 193, 177, 38, 13, dwLabelStyle);
            hCtrl = addComboBox(hWnd, ID_COUNTRY, $NULL, 235, 174, 194, 170, WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_VSCROLL | CBS_DROPDOWNLIST | CBS_HASSTRINGS | CBS_NOINTEGRALHEIGHT);
            addCountries(hCtrl);

            hCtrl = addLabel(hWnd, - ID_PHONE, L"Phone", 8, 206, 90, 13, dwLabelStyle);
            hCtrl = addTextBox(hWnd, ID_PHONE, $NULL, 102, 203, 225, 20, dwEditStyle);

            hCtrl = addLabel(hWnd, - ID_FAX, L"Fax", 329, 206, 27, 13, dwLabelStyle);
            hCtrl = addTextBox(hWnd, ID_FAX, $NULL, 362, 203, 225, 20, dwEditStyle);

            hCtrl = addLabel(hWnd, - ID_EMAIL, L"Email", 8, 234, 90, 13, dwLabelStyle);
            hCtrl = addTextBox(hWnd, ID_EMAIL, $NULL, 102, 231, 225, 19, dwEditStyle);

            hCtrl = addLabel(hWnd, - ID_URL, L"www", 331, 234, 27, 13, dwLabelStyle);
            hCtrl = addTextBox(hWnd, ID_URL, $NULL, 362, 231, 225, 19, dwEditStyle);

            hCtrl = addLabel(hWnd, - ID_COMMENTS, L"Comments", 8, 260, 90, 13, dwLabelStyle);
            hCtrl = addTextBox(hWnd, ID_COMMENTS, $NULL, 102, 257, 485, 105, dwEditStyle | WS_VSCROLL | ES_MULTILINE | ES_WANTRETURN);

            DWORD dwStyle = WS_CHILD | WS_VISIBLE | WS_TABSTOP;
            hCtrl = addButton(hWnd, ID_PRIOR,  L"<<  Prior",  16, 379, 60, 22, dwStyle);
            hCtrl = addButton(hWnd, ID_NEXT,   L"Next  >>",   89, 379, 60, 22, dwStyle);
            hCtrl = addButton(hWnd, ID_FIND,   L"Find",      162, 379, 60, 22, dwStyle);
            hCtrl = addButton(hWnd, ID_ADD,    L"Add",       235, 379, 60, 22, dwStyle);
            hCtrl = addButton(hWnd, ID_UPDATE, L"Update",    308, 379, 60, 22, dwStyle);
            hCtrl = addButton(hWnd, ID_DELETE, L"Delete",    381, 379, 60, 22, dwStyle);
            hCtrl = addButton(hWnd, ID_PRINT,  L"Print",     454, 379, 60, 22, dwStyle);
            hCtrl = addButton(hWnd, IDCANCEL,  L"Close",     527, 379, 60, 22, dwStyle);
            SetButtonStatus(hWnd);

            HMENU hMenu = CreateMenu();
               HMENU hPopMenu = CreatePopupMenu();
               AppendMenu(hMenu, MF_POPUP, (LONG_PTR) hPopMenu, L"File");
                  AppendMenu(hPopMenu, 0, 2, L"Close");
               hPopMenu = CreatePopupMenu();
               AppendMenu(hMenu, MF_POPUP, (LONG_PTR) hPopMenu, L"Help");
                  AppendMenu(hPopMenu, 0, ID_MENU_HELP, L"Help");
                  AppendMenu(hPopMenu, MF_SEPARATOR, 0, $NULL);
                  AppendMenu(hPopMenu, 0, ID_MENU_ABOUT, L"About");
            SetMenu(hWnd, hMenu);

            UdtToDialog(hWnd, gP.currententry);

            ShowWindow(hWnd, nCmdShow);
            UpdateWindow(hWnd);

            while (GetMessage(&msg, NULL, 0, 0)) {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }

            // Save our data file if any changes were made
            if (gP.isfilemodified) {
                //array sort gAddressBook[1] FOR gP.maxentries,
                //           from 1 to len(gAddressBook[1].Company + gAddressBook[1].LastName)
                hFile = CreateFile(szFilename, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
                if (hFile != INVALID_HANDLE_VALUE) {
                    WriteFile(hFile, &gAddressBook[0], gP.maxentries * sizeof(AddressType), &BytesWritten, NULL);
                    CloseHandle(hFile);
                }
            }

            nRet = (long) msg.wParam;
        }
    }
    return nRet;
}
